// Namespace
var android = {};
android.selection = {};
	
android.selection.selectionStartRange = null;
android.selection.selectionEndRange = null;


/** The last point touched by the user. { 'x': xPoint, 'y': yPoint } */
android.selection.lastTouchPoint = null;

/** Loadrange boolean variable */
android.selection.loadrange=false;

/** 
 * Function for removing an element
 */

android.selection.removeElement = function(id){
   window.TextSelection.jsError("Before removeElement");
   var el = document.getElementById(id);
   var remElement = (el.parentNode).removeChild(el);
   window.TextSelection.jsError("Inside Remove Element"+id);
   };


/** 
 * Starts the touch and saves the given x and y coordinates as last touch point
 */
android.selection.startTouch = function(x, y){
	
	android.selection.lastTouchPoint = {'x': x, 'y': y};
	
};

/**
*   Load Rangy.
*/

android.selection.loadRangy = function(){
   try{
      if(!android.selection.loadrange){
      document.execCommand("MultipleSelection", null, true);
      rangy.init();
      var serializerModule = rangy.modules.Serializer;
      window.TextSelection.jsError("Inside LoadRangy");
      android.selection.loadrange=true;
      window.TextSelection.setLoadRangy("true");
      }
   }
   catch(err){
		window.TextSelection.jsError(err);
	}
};



/**
 *	Checks to see if there is a selection.
 *
 *	@return boolean
 */
android.selection.hasSelection = function(){
	return window.getSelection().toString().length > 0;
};


/**
 *	Clears the current selection.
 */
android.selection.clearSelection = function(){
	
	try{
		// if current selection clear it.
	   	var sel = window.getSelection();
	   	sel.removeAllRanges();
	}catch(err){
		window.TextSelection.jsError(err);
	}	
};


/**
 *	Handles the long touch action by selecting the last touched element.
 */
android.selection.longTouch = function() {				

	try{
	
        android.selection.loadRangy();   
    	android.selection.clearSelection();
    	
	   	// if current selection clear it.
	   	var sel = window.getSelection();
	   	
	   	var oneWordCaret = document.caretRangeFromPoint(android.selection.lastTouchPoint.x, android.selection.lastTouchPoint.y);
	   	oneWordCaret.expand("word");
			
	   	
	   	sel.addRange(oneWordCaret);
	   	
	   	var temp = sel.getRangeAt(0);
	   	
	   	android.selection.saveSelectionStart();
	   	android.selection.saveSelectionEnd();
	   	
	   	
	   	// Show the context menu in app
	   	android.selection.selectionChanged();
	   	//android.selection.selectBetweenHandles();
	   	
	 }
	 catch(err){
	 	window.TextSelection.jsError(err);
	 }
   	
};

/**
 * Tells the app to show the context menu. 
 */
android.selection.selectionChanged = function(){

	try{
	
		var sel = window.getSelection();
		if(!sel){
			return;
		}
		
		var range = sel.getRangeAt(0);
		//var rangyRange = rangy.serializeRange(range,true,null);
		//window.TextSelection.jsError("Value of Rangy range1::"+rangyRange);
		
		
		/*
		// Add spans to the selection to get page offsets
		var selectionEnd = $("<span id=\"selectionEnd\"/>");
	    var selectionStart = $("<span id=\"selectionStart\"/>");
	    
		
		var startRange = document.createRange();
    	startRange.setStart(range.startContainer, range.startOffset);
    	startRange.insertNode(selectionStart[0]);
		
		var endRange = document.createRange();
    	endRange.setStart(range.endContainer, range.endOffset);
    	endRange.insertNode(selectionEnd[0]);
    	
	    
	   	
	   	// Create the bounds json object for the selection
	   	var handleBounds = "{'left': " + selectionStart.offset().left + ", ";
	   	handleBounds += "'top': " + selectionStart.offset().top + ", ";
	   	handleBounds += "'right': " + selectionEnd.offset().left + ", ";
	   	handleBounds += "'bottom': " + selectionEnd.offset().top + "}";
	   	   	   	
	   	// Pull the spans
	    selectionStart.remove();
	   	selectionEnd.remove(); */
	   		   	
	   	//var bodyText = document.body.innerHTML;
	   	//window.TextSelection.jsError("Body Text::"+bodyText);
	   		   	
	   	// Reset range
	   	sel.removeAllRanges(); 
	    sel.addRange(range);
	    	   
	   	// Menu bounds
	    var rect = range.getBoundingClientRect();
	   	   		   	
	   	var menuBounds = "{'left': " + rect.left + ", ";
	   	menuBounds += "'top': " + rect.top + ", ";
	   	menuBounds += "'right': " + rect.right + ", ";
	   	menuBounds += "'bottom': " + rect.bottom + "}";
	   	   	
	   	//Get rangy range	   	
	   	var rangyRange = rangy.serializeRange(range,true,null);
	   	window.TextSelection.jsError("Value of Rangy range2::"+rangyRange);
	   	// Text to send to the selection
	   	var text = window.getSelection().toString();
	   	
	   	// Set the content width
	   	window.TextSelection.setContentWidth(document.body.clientWidth);
	   	// Tell the interface that the selection changed
	   	window.TextSelection.selectionChanged(rangyRange, text, menuBounds, menuBounds);
	   	
	}
	catch(err){
		window.TextSelection.jsError(err);
	}
};



android.selection.getRange = function() {
    window.TextSelection.jsError("Inside get Range::"+rangy);
    var serializedRangeSelected = rangy.serializeSelection();
    window.TextSelection.jsError("Inside get Range:"+serializedRangeSelected);
    var serializerModule = rangy.modules.Serializer;
    if (serializedRangeSelected != '') {
        if (rangy.supported && serializerModule && serializerModule.supported) {
            var beginingCurly = serializedRangeSelected.indexOf("{");
            serializedRangeSelected = serializedRangeSelected.substring(0, beginingCurly);
            return serializedRangeSelected;
        }
    }
}



/** 
 * Returns the last touch point as a readable string.
 */
android.selection.lastTouchPointString = function(){
	if(android.selection.lastTouchPoint == null)
		return "undefined";
		
	return "{" + android.selection.lastTouchPoint.x + "," + android.selection.lastTouchPoint.y + "}";
};



android.selection.saveSelectionStart = function(){
	try{

		// Save the starting point of the selection
	   	var sel = window.getSelection();
		var range = sel.getRangeAt(0);
		
		var saveRange = document.createRange();
		
		window.TextSelection.jsError("Start Range Container::"+range.startContainer+"  Start Range Offset::"+range.startOffset);
		
		saveRange.setStart(range.startContainer, range.startOffset);
		
		android.selection.selectionStartRange = saveRange;
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

android.selection.saveSelectionEnd = function(){

	try{

		// Save the end point of the selection
	   	var sel = window.getSelection();
		var range = sel.getRangeAt(0);
		
		var saveRange = document.createRange();
		saveRange.setStart(range.endContainer, range.endOffset);
		
		android.selection.selectionEndRange = saveRange;
	}catch(err){
		window.TextSelection.jsError(err);
	}
	
};



/**
 * Sets the last caret position for the start handle.
 */
android.selection.setStartPos = function(x, y){
	
	try{
		android.selection.selectionStartRange = document.caretRangeFromPoint(x, y);
		android.selection.selectBetweenHandles();
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

/**
 * Sets the last caret position for the end handle.
 */
android.selection.setEndPos = function(x, y){
	
	try{	
		android.selection.selectionEndRange = document.caretRangeFromPoint(x, y);
		
		android.selection.selectBetweenHandles();
	
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

/**
 *	Selects all content between the two handles
 */
android.selection.selectBetweenHandles = function(){
	
	try{
		var startCaret = android.selection.selectionStartRange;
		var endCaret = android.selection.selectionEndRange;
		
		// If we have two carets, update the selection
		if (startCaret && endCaret) {
			// If end caret comes before start caret, need to flip
			if(startCaret.compareBoundaryPoints (Range.START_TO_END, endCaret) > 0){
				var temp = startCaret;
				startCaret = endCaret;
				endCaret = temp;
				android.selection.selectionStartRange = startCaret;
				android.selection.selectionEndRange = endCaret;
			}
			
			var range = document.createRange();
			range.setStart(startCaret.startContainer, startCaret.startOffset);
			range.setEnd(endCaret.startContainer, endCaret.startOffset);
			android.selection.clearSelection();
			var selection = window.getSelection();
			selection.addRange(range);
			
		}
		
		android.selection.selectionChanged();
   	}
   	catch(err){
   		window.TextSelection.jsError(err);
   	}
};

/**
* Selection Between Two Points
* Creates SelectionStartRange and selectionEndRange
*/

android.selection.selectBetweenPoints = function(x1,y1,x2,y2){

    try{
    android.selection.loadRangy();  
    
    android.selection.selectionStartRange = document.caretRangeFromPoint(x1, y1);
    android.selection.selectionEndRange = document.caretRangeFromPoint(x2, y2);
    android.selection.selectBetweenHandles();
    }
    catch(err){
         window.TextSelection.jsError(err);
    }

};

/**
*
*   For Highlighting 
*/

/**
*   @@ // the style is a string of css styles. eg."background-color:darkblue; color:blue;"
*   Highliting From Menu
*/
android.selection.styleRange = function(range, style) 
{
// Get the start and end nodes and split them to give new start and end nodes with only text that falls inside the range.
try{
var startNode;
var endNode;
style="background-color:yellow; color:red;";
var sel = window.getSelection();
range = sel.getRangeAt(0);

if(range.startContainer.nodeType == 3){
startNode = range.startContainer.splitText(range.startOffset);
}else{
startNode = range.startContainer;
}

if(range.endContainer.nodeType == 3){
try{
endNode = range.endContainer.splitText(range.endOffset).previousSibling;
}
catch(ex){
endNode = startNode.splitText(range.endOffset-range.startOffset).previousSibling;
}
}else{
endNode = range.endContainer;
}

// Adjust the range to contain the new start and end nodes
// The offsets are not really important anymore but might as well set them correctly
range.setStart(startNode,0);
range.setEnd(endNode,endNode.length);
// Get an array of all text nodes within the range
var nodes = android.selection.getNodesInRange(range);
window.TextSelection.jsError("Inside stylerange::"+nodes);

// Place span tags with style around each textnode
for (i = 0; i < nodes.length; i++)
{
window.TextSelection.jsError("Inside stylerange For loop::");
var span = document.createElement('span');
//span.setAttribute("id",'SEL1'+selectionId);
span.setAttribute("id",'SEL1');
span.setAttribute("style", style);
span.appendChild( document.createTextNode(nodes[i].nodeValue));
nodes[i].parentNode.replaceChild( span, nodes[i] );
}
window.TextSelection.jsError("Inside style range over");
}
catch(err){
   		window.TextSelection.jsError(err);
   	}
};

/**
*   @@ // the style is a string of css styles. eg."background-color:darkblue; color:blue;"
*   Highliting From Deserilization
*/
android.selection.deserialize = function(serial) 
{
// Get the start and end nodes and split them to give new start and end nodes with only text that falls inside the range.
window.TextSelection.jsError("Inside deserialize::"+serial);
try{
var startNode;
var endNode;
android.selection.loadRangy();
style="background-color:yellow; color:red;";
window.TextSelection.jsError("Before deserialize"+rangy);
//var sel = rangy.deserializeSelection(serial,null,null);
//range = sel.getRangeAt(0);
if(rangy.canDeserializeRange(serial,null,null))
window.TextSelection.jsError("deserialize True");
else
window.TextSelection.jsError("deserialize False");
range=rangy.deserializeRange(serial,null,null);
if(range.startContainer.nodeType == 3){
startNode = range.startContainer.splitText(range.startOffset);
}else{
startNode = range.startContainer;
}

if(range.endContainer.nodeType == 3){
try{
endNode = range.endContainer.splitText(range.endOffset).previousSibling;
}
catch(ex){
endNode = startNode.splitText(range.endOffset-range.startOffset).previousSibling;
}
}else{
endNode = range.endContainer;
}

// Adjust the range to contain the new start and end nodes
// The offsets are not really important anymore but might as well set them correctly
range.setStart(startNode,0);
range.setEnd(endNode,endNode.length);
// Get an array of all text nodes within the range
var nodes = android.selection.getNodesInRange(range);
window.TextSelection.jsError("Inside stylerange::"+nodes);

// Place span tags with style around each textnode
for (i = 0; i < nodes.length; i++)
{
window.TextSelection.jsError("Inside stylerange For loop::");
var span = document.createElement('span');
//span.setAttribute("id",'SEL1'+selectionId);
span.setAttribute("id",'SEL1');
span.setAttribute("style", style);
span.appendChild( document.createTextNode(nodes[i].nodeValue));
nodes[i].parentNode.replaceChild( span, nodes[i] );
}
window.TextSelection.jsError("Inside style range over");
}
catch(err){
   		window.TextSelection.jsError(err);
   	}
};




android.selection.getNodesInRange = function(range)
{
try{
var start = range.startContainer;
var end = range.endContainer;
var commonAncestor = range.commonAncestorContainer;
var nodes = [];
var node;

// walk parent nodes from start to common ancestor
for (node = start.parentNode; node; node = node.parentNode)
{
if (node.nodeType == 3) //modified to only add text nodes to the array
nodes.push(node);
if (node == commonAncestor)
break;
}
nodes.reverse();

// walk children and siblings from start until end is found
for (node = start; node; node = android.selection.getNextNode(node))
{
if (node.nodeType == 3) //modified to only add text nodes to the array
nodes.push(node);
if (node == end)
break;
}
window.TextSelection.jsError("Inside getNodesInRange");
return nodes;

}
catch(err)
   {
    window.TextSelection.jsError(err);
    return null;
   }
};


android.selection.getNextNode = function(node, end)
{
try{
if (node.firstChild)
return node.firstChild;
while (node)
{
if (node.nextSibling)
return node.nextSibling;
node = node.parentNode;
}
window.TextSelection.jsError("Inside GenNextNode");
}
catch(err)
      {
          window.TextSelection.jsError(err);
          }
};



