let ZDWebViewEditorJSHandler = {
    setEditable : function(isEditable) {
        document.body.contentEditable = isEditable;
        setEventListener(isEditable);
    },
    setHint : function(hint) {
        document.body.setAttribute("data-text", hint); //No I18N
    },
    setFocusToContent: function() {
        document.body.focus();
        document.execCommand('selectAll', false, null); //No I18N
        document.getSelection().collapseToEnd();
    }
}

let inputEventListener = function (event) {
    ZDWebViewNativeHandler.onContentChanged(ZDWebViewJsHandler.getContent());
}

function setEventListener(isAdd) {
    if(isAdd) {
        document.body.addEventListener("input", inputEventListener); //No I18N
        document.body.addEventListener("keyup", onKeyUpEventListener); //No I18N
        document.body.addEventListener("focus", onFocusListener); //No I18N
        document.body.addEventListener("blur", onBlurListener); //No I18N
    } else {
        document.body.removeEventListener("input", inputEventListener); //No I18N
        document.body.removeEventListener("keyup", onKeyUpEventListener); //No I18N
        document.body.removeEventListener("focus", onFocusListener); //No I18N
        document.body.removeEventListener("blur", onBlurListener); //No I18N
    }
}

let onFocusListener = function() {
    var point = getCaretCoordinates();
    ZDWebViewNativeHandler.onFocusChange(true, point.x);
}

let onBlurListener = function() {
    ZDWebViewNativeHandler.onFocusChange(false, null);
}

let onKeyUpEventListener = function (event) {
    var point = getCaretCoordinates();
    ZDWebViewNativeHandler.onKeyUp(point.x);
}

function getCaretCoordinates() {
    var sel = document.selection, range, rect;
    var x = 0, y = 0;
    if (sel) {
        if (sel.type != "Control") { //No I18N
            range = sel.createRange();
            range.collapse(true);
            x = range.boundingTop;
            y = range.boundingHeight;
        }
    } else if (window.getSelection) {
        sel = window.getSelection();
        if (sel.rangeCount) {
            range = sel.getRangeAt(0).cloneRange();
            if (range.getClientRects) {
                range.collapse(true);
                if (range.getClientRects().length>0){
                    rect = range.getClientRects()[0];
                    x = rect.top;
                    y = rect.bottom;
                }
            }
            if (x == 0 && y == 0) {
                var span = document.createElement("span"); //No I18N
                if (span.getClientRects) {
                    span.appendChild( document.createTextNode("M") ); //No I18N
                    range.insertNode(span);
                    rect = span.getClientRects()[0];
                    x = rect.top;
                    y = rect.bottom;
                    var spanParent = span.parentNode;
                    spanParent.removeChild(span);

                    spanParent.normalize();
                }
            }
        }
    }
    return { x: x, y: y };
}