let ZDWebViewJsHandler = {
    appendBaseNode : function (href) {
        if(href.trim()) {
            var baseNode = document.createElement('base'); //No I18N
            baseNode.href = href;
            document.head.appendChild(baseNode);
        }
    },
    setBackgroundColor : function (backgroundColor) {
        if(backgroundColor.trim()) {
            document.body.style.backgroundColor = backgroundColor;
        }
    },
    setColor : function (color) {
        if(color.trim()) {
            document.body.style.color = color;
        }
    },
    setFontSize : function (fontSize) {
        document.body.style.fontSize = fontSize + 'px'; //No I18N
    },
    setContent : function (content, isHtml) {
        if(isHtml) {
            document.body.innerHTML = content;
        } else {
            document.body.innerText = content;
        }
        document.body.setAttribute("is-html", isHtml); //No I18N
        ZDWebViewNativeHandler.onContentLoaded()
    },
    getContent : function () {
        var isHtml = document.body.getAttribute("is-html") == "true"; //No I18N
        if(isHtml) {
            return document.body.innerHTML
        } else {
            return document.body.innerText
        }
    },
    getPlainText : function () {
        return document.body.innerText
    },
    setLineHeight: function (lineHeight) {
        if(lineHeight > 0) {
            document.body.style.lineHeight = lineHeight + 'px' //No I18N
        }
    },
    setDirection: function (direction) {
        document.body.style.direction = direction;
    }
}