function setThreadContent(content, isDarkTheme)
{
        document.body.innerHTML = content;
        var blockquote = document.body.getElementsByTagName('blockquote')[0];
        if (typeof blockquote !== "undefined") {
            var parent = blockquote.parentElement;
            var para = document.createElement("threeDot");
            var dotBorderColor = isDarkTheme ? "#fff" : "#aaa"; //No I18N
            var node = '<br /><svg style="height: 13px;width: 31px;border: 1px solid '+dotBorderColor+';border-radius: 5px;" viewBox="0 0 32 32"><g><path fill='+dotBorderColor+' d="M3.5,19.5C1.6,19.5,0,17.9,0,16c0-1.9,1.6-3.5,3.5-3.5S7,14.1,7,16C7,17.9,5.4,19.5,3.5,19.5z"></path><path fill='+dotBorderColor+' d="M15.8,19.5c-1.9,0-3.5-1.6-3.5-3.5c0-1.9,1.6-3.5,3.5-3.5s3.5,1.6,3.5,3.5C19.3,17.9,17.7,19.5,15.8,19.5z"></path><path fill='+dotBorderColor+' d="M28.5,19.5c-1.9,0-3.5-1.6-3.5-3.5c0-1.9,1.6-3.5,3.5-3.5S32,14.1,32,16C32,17.9,30.4,19.5,28.5,19.5z"></path></g></svg>';
            para.innerHTML=node;
            para.addEventListener("click",function(){
                blockquoteClick(blockquote)
            });
            parent.insertBefore(para,blockquote);
            blockquote.style.display = "none";
        }
        if(isDarkTheme) {
            enhanceReadabilityForDarkTheme();
        } else {
            ThreadContent.onContentLoaded();
        }
}

function blockquoteClick(blockquote)
{
        if( blockquote.style.display === 'none'){
            blockquote.style.display = "block";
        }else{
            blockquote.style.display = "none";
        }
}